package dniYMatricula;

import java.util.Scanner;

public class Eac4P1_002 {

	//Constante
	private static final int MAX = 10;

	//Variables globales
	//Array que guarda Matrícula y DNI
	private String[][] ListaMATDNIs = new String[MAX][2]; 
	//Array que guarda DNI y Nombre
	private String[][] ListaDNINombres = new String[MAX][2]; 
	//Variables de contador que recorren los arrays
	int indexDNI = 0; 
	int indexMatricula = 0; 
	String matricula, dni, nombre, matriConsulta, dniConsulta, nomConsulta;
	boolean finalizar, DNIcoinciden = false;
	Scanner scanner = new Scanner(System.in);

	public static void main(String[] args) {
		Eac4P1_002 programa = new Eac4P1_002();
		programa.inicio();
	}

	//Metodo de inicio
	private void inicio() {
		mostrarPresentacion();

		while ((indexMatricula < MAX)&&(!finalizar)) {
			pedirDatos();
		}	
		finPrograma();
	}

	//Metodo que resuelve el subproblema de presentar el programa
	private void mostrarPresentacion() {
		System.out.println("**** Este programa almacena datos de ******\n"
				+ "********** Matrículas y Personas **********\n"
				+ "*******************************************\n"
				+ "***** Escribe - fin - para finalizar ******\n"
				+ "*******************************************");
	}


	//Metodo que resuelve el subproblema de pedir los datos.
	private void pedirDatos() {
		//Solicitamos datos de matrícula
		int contVehículos = indexMatricula + 1;
		System.out.print("***** Vehículo # " + contVehículos + 
				"\nIntroduce la matrícula:");
		matricula = scanner.nextLine();
		//Si escribimos fin cerramos el programa.
		if (matricula.equalsIgnoreCase("fin")) {
			finalizar = true;
			return; 
		}

		//buscarDNIByMatricula();//sustituido por yaExisteMatricula()

		if (!yaExisteMatricula()) {//El siguiente codigo solo se ejecuta si NO EXISTE la matricula

			//Pedimos el DNI por teclado
			System.out.print("Introduce el dni: ");
			dni = scanner.nextLine();
	
			//Si escribir fin cerramos el programa.
			if (dni.equalsIgnoreCase("fin")) {
				finalizar = true;
				return;
			}
	
	
			//buscarPersonaByDNI();//Sustituido por buscarPersonaByDNI_Alternativo()
			
			nomConsulta = buscarPersonaByDNI_Alternativo();
			if (nomConsulta != null) {//Tenemos un nombre valido
				agregarVehiculo();
			}
			else {//No tenemos nombre, para este DNI porque es nuevoen el arrray
				System.out.print("Introduce el nombre del titular: ");
				nombre = scanner.nextLine();
				if (nombre.equalsIgnoreCase("fin")) {
					finalizar = true;
	
				}
				else {//Importante el else. DE lo contrario, agregariamos a alguien con nombre "fin"
					agregarPersona();
					agregarVehiculo();
				}
			}
	
	
			/*
			//Si los valores dni y dniConsulta son iguales no se pide el nombreel titular
			if (DNIcoinciden) {
				agregarVehiculo();
			} else {
				//Pedimos Nombre por teclado - Sólo si el DNI es nuevo en el array.
				System.out.print("Introduce el nombre del titular: ");
				nombre = scanner.nextLine();
	
				//si escribir fin cerramos el programa.
				if (nombre.equalsIgnoreCase("fin")) {
					finalizar = true;
	
				}
				agregarPersona();
				agregarVehiculo();
			}*/
		}
	}

	/*Método que resuelve el subproblema de asignar datos al array de 
	 * DNIs y Nombres - ListaDNINombres.*/
	private void agregarPersona() {
		ListaDNINombres[indexDNI][0]=dni;
		ListaDNINombres[indexDNI][1]=nombre;
		indexDNI++;	 
	}
	/*Método que resuelve el subproblema de asignar datos al array de 
	 * Matrículas y DNIs - ListaMATDNIs.*/
	private void agregarVehiculo() {
		ListaMATDNIs[indexMatricula][0]= matricula;
		ListaMATDNIs[indexMatricula][1]= dni;
		indexMatricula++;
		if(indexMatricula == MAX){
			finalizar = true;
		}else {
			/*
			 * OJO, LLamada recursiva. Hay que evitarlo.
			 * De hecho, aqui no hay que llamar a pedirDatos()
			 * Este metodo volverá a ejecutarse el solito porque
			 * ahora mismo finalizar == false
			 */
			
			//pedirDatos();
		}
	}

	private boolean yaExisteMatricula() {

		for (int i = 0; i < indexMatricula; i++) {
			if (ListaMATDNIs[i][0].equalsIgnoreCase(matricula)) {
				System.out.println("La matrícula "+ matricula +" ya existe. Corresponde a " 
						+ ListaDNINombres[i][1] + "\n Introduce una nueva matrícula." 
						+ "\n*****************");
				return true;
			}
		}

		//Si el bucle ha conseguido terminar, es que no existe la matricula. Por tanto, retornamos false
		return false;
	}

	//Mètode que resol el subproblema de cercar un Dni  partir de la Matricula
	private void buscarDNIByMatricula() {

		boolean encontrado = false;

		// comprovar si la matricula ja existeix
		// assignar a matriConsulta la matricula trobada
		// assignar a dniConsulta el dni trobat
		for (int i = 0; i < indexMatricula && (!encontrado); i++) {
			if (ListaMATDNIs[i][0].equalsIgnoreCase(matricula)) {
				encontrado = true;
				matriConsulta = matricula;
				dniConsulta = ListaMATDNIs[i][1];
				nomConsulta = ListaDNINombres[i][1];
				System.out.println("La matrícula "+ ListaMATDNIs[i][0] +" existe. Corresponde a " 
						+ nomConsulta + "\n Introduce una nueva matrícula." 
						+ "\n*****************");
				pedirDatos();

			}
		}

	}

	private String buscarPersonaByDNI_Alternativo() {
		
		for (int i = 0; i < indexDNI; i++) {
			if (ListaDNINombres[i][0].equalsIgnoreCase(dni)) {
				//DNI encontrado, informamos y devolvemos el nombre del titular
				System.out.println("DNI encontrado. Corresponde a " + ListaDNINombres[i][1]);
				return ListaDNINombres[i][1];
			}
		}
		
		//Si el bucle ha conseguido terminar, es que no existe este DNI. Retornamos valor null
		return null;
	}

	//Método que resuelve el problema de buscar el nombre a partir del DNI 
	private void buscarPersonaByDNI() {
		boolean encontrado = false;
		DNIcoinciden = false;
		// Se asignan los datos de dni y nombre al array ListaDNINombres	      
		for (int i=0; i < indexDNI&&(!encontrado); i++) {
			if (ListaDNINombres[i][0].equalsIgnoreCase(dni)) {
				encontrado = true;
				dniConsulta = ListaDNINombres[i][0];
				nomConsulta = ListaDNINombres[i][1];
				System.out.println("DNI encontrado. Corresponde a " + nomConsulta);
				DNIcoinciden = true; 		  

			}
		}

	}
	
	//Método de finalización de programa
	private void finPrograma() {
		//Recupero el mostrado de matrices en pantalla
		System.out.println("\n\n\tMATRICULAS Y DNI");
		for (int i = 0; i < indexMatricula; i++) {
			System.out.println("\t" + ListaMATDNIs[i][0] + "\t" + ListaMATDNIs[i][1]);
		}
		System.out.println("\n\n\tDNI Y NOMBRES");
		for (int i = 0; i < indexDNI; i++) {
			System.out.println("\t" + ListaDNINombres[i][0] + "\t" + ListaDNINombres[i][1]);
		}
		
		System.out.println("\nPrograma finalizado");
		//finalizar = true; Innecesario, llegados a este metodo, el valor de esta variable carece de importancia
	}

}
